
/*   Brian:   this source is on page 2-21 in the ESQL Manual  */

$include sqlca;
$include sqlda;
$include sqltypes;

#include <stdio.h>
#define DSTRSZ 40

rtypalign();

main()
{
    register i;
    int size;
    char decstr[DSTRSZ];
    struct sqlda *q_desc;
    struct sqlvar_struct *col;
    char *buffer = NULL;
    char *malloc();

$    char q_string[128];

$    database demo;

     strcpy( q_string, "select * from tbagent into temp x");

$    prepare q_id from $q_string;
     if (sqlca.sqlcode != 0) {
        printf( "'Prepare' error %d\r\n", sqlca.sqlcode);
        return;
        }


$    describe q_id into q_desc;
     if (sqlca.sqlcode != 0) {
        printf("'Describe' error %d\r\n", sqlca.sqlcode);
        return;
        }

     size = 0;
     for ( col=q_desc->sqlvar, i=0; i < q_desc->sqld; col++, i++) {
          switch(col->sqltype) {
              case SQLSMFLOAT:
                   size = rtypalign(size, CFLOATTYPE);
                   col->sqltype = CFLOATTYPE;
                   col->sqllen  = rtypmsize(CFLOATTYPE, 0);
                   size += col->sqllen;
                   break;
              case SQLFLOAT:
                   size = rtypalign(size, CDOUBLETYPE);
                   col->sqltype = CDOUBLETYPE;
                   col->sqllen  = rtypmsize(CDOUBLETYPE, 0);
                   size += col->sqllen;
                   break;
              case SQLMONEY:
              case SQLDECIMAL:
                   size = rtypalign(size, CDECIMALTYPE);
                   col->sqltype = CDECIMALTYPE;
                   col->sqllen  = rtypmsize(CDECIMALTYPE, 0);
                   size += col->sqllen;
                   break;
              default:        
                   size = rtypalign(size, CFIXCHARTYPE);
                   col->sqllen  = rtypwidth(col->sqltype, col->sqllen)+1;
                   col->sqltype = CFIXCHARTYPE;
                   size += col->sqllen;
                   break;

              }   /* end of switch statement */

          }   /* end of for loop */

     buffer = malloc(size);
     if (buffer == NULL) {
        printf( "Out of memory\r\n");
        return;
        }

    size = 0;
    for (col=q_desc->sqlvar, i=0; i < q_desc->sqld; col++, i++) {
        size = rtypalign(size, col->sqltype);
        col->sqldata = size + buffer;
        size += col->sqllen;
        if (col->sqltype != CDECIMALTYPE)
           size++;
        }
        

              

$    declare q_cursor cursor for q_id;
     if (sqlca.sqlcode != 0) {
        printf( "'Declare' error %d\r\n", sqlca.sqlcode);
        return;
        }

$    open q_cursor;
     if (sqlca.sqlcode != 0) {
        printf("'Open cursor' error %d\r\n", sqlca.sqlcode);
        return;
        }


     for (;;) {

         $    fetch q_cursor using descriptor q_desc;
     
         if (sqlca.sqlcode == 100) {
            printf("\r\nEnd of Fetch loop\r\n");
            break;
            }

         if (sqlca.sqlcode < 0) {
            printf("'Fetch Error' error %d", sqlca.sqlcode);
            break;
            }
        
         printf( "\nFetch\n");
     
         for (col=q_desc->sqlvar, i=q_desc->sqld; i > 0; col++, i--) {
             if (col->sqltype == CDECIMALTYPE) {
                 dectoasc(col->sqldata, decstr, DSTRSZ, -1);
                 ldchar(decstr, DSTRSZ, decstr);
                 printf("%s, ", decstr);
                 }
             else {
                 printf("%s, ", col->sqldata);
                 }
             } /* end of for loop */
         }

     printf("\r\n");  
     
     free(buffer);

$    close q_cursor;

$    close database;

     exit(0);
}


