
  drop table menuhead onerror warning;

    create table menuhead
       (menuname      char(10),
        title1        char(76),
        title2        char(76),
        prevmenu      char(10),
        template      char(18),
        ncolumns      smallint,
        nmenufields   smallint,
        format        char(1),
        urow          smallint,
        ucol          smallint,
        lrow          smallint,
        lcol          smallint
         );


   create unique index mhmenukey
        on menuhead ( menuname);


    insert into menuhead
         (menuname, title1, title2, prevmenu, template, ncolumns, nmenufields, urow, ucol, lrow, lcol)
       values
         ("QC", "Configuration Menu", "", "", "config", "0", "0", "0", "0", "0", "0");


   drop table menufield onerror warning ; 

    create table menufield
       (menuname      char(10),
        itemnum       smallint,
        itemdesc      char(60),
        menufieldid   serial,
        exectype      char(1),
        execline      char(80),
        password      char(8),
        clearscr      char( 1),
        startcr       char(1),
        endcr      char(1)
         );

   create unique index mfmenukey
        on menufield ( menuname, itemnum);

/*
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "1", "Build Dictionary", "P", "qfbuild", "", "Y","","Y");
*/
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "1", "Setup Control File", "P", "qfcfg qfctl c", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "2", "Load", "P", "qfcfg qfload", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "3", "Update", "P", "qfcfg qfdict", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "4", "Print", "P", "qfcfg qfdictr", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "5", "Define Joins", "P", "qfcfg qfdictj", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "6", "Print Joins", "P", "qfcfg qfdictjr", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "7", "Cleanup", "P", "qfcfg qfdictc", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "8", "Design", "P", "qfcfg qfmenu", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "9", "Print", "P", "qfcfg qfmenur", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "10", "Run", "P", "qffront qffront", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "11", "Cleanup", "P", "qfcfg qfmenuc", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "12", "Define User Types", "P", "qfcfg qfperms -f qfustytable", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "13", "Define Users", "P", "qfcfg qfperms -f qfusertable", "", "","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("QC","14","Printer Control","P","qfprnt","","Y","","Y");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("QC","15","Printer Configuration","P","flexprc","","Y","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("QC","16","Terminal Control","P","qfterm","","Y","","Y");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "17", "Backup", "P", "qfbackup", "", "","","");
insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("QC", "18", "Restore", "P", "qfrest", "", "","","");



    drop table menuuser onerror warning; 
    create table menuuser
       (usercode      char(10),  /* usually login name */
        usertype    char(10),
        password      char(10),
        flag1         char(1),
        flag2         char(1),
        flag3         char(1),
        description   char(25)
        );
   create unique index menuuserkey
        on menuuser (usercode);

    drop table menuusty onerror warning; 
    create table menuusty
       (usertype    char(10),
        menuname      char(10),
        password      char(10),
        osflag        char(1),
        flag1         char(1),
        flag2         char(1),
        flag3         char(1),
        description   char(25)
        );
   create unique index menuustykey
        on menuusty (usertype);

    drop table menuperm onerror warning;
    create table menuperm
       (usertype  char(10), 
        menufieldid integer,
        permtype  char(1),
        permlist  char(30),
        execline    char(30),
        password      char(10)
        );
   create unique index menupermkey
        on menuperm (usertype, menufieldid);


